Bug 1398575 - FTBFS on s390x and ppc64
Summary: FTBFS on s390x and ppc64
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: golang-github-vishvananda-netlink
Version: 25
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jan Chaloupka
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: ZedoraTracker PPCTracker 1396472 1404679
TreeView+ depends on / blocked
 
Reported: 2016-11-25 10:39 UTC by Dan Horák
Modified: 2017-12-12 13:12 UTC (History)
8 users (show)

Fixed In Version: golang-github-vishvananda-netlink-0-0.11.gite73bad4.fc24 golang-github-vishvananda-netlink-0-0.11.gite73bad4.fc25 golang-github-vishvananda-netlink-0-0.11.gite73bad4.el6
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1404679 (view as bug list)
Environment:
Last Closed: 2017-12-12 10:19:05 UTC


Attachments (Terms of Use)

Description Dan Horák 2016-11-25 10:39:20 UTC
golang-github-vishvananda-netlink fails to build on s390x and ppc64

s390x:
Executing(%check): /bin/sh -e /var/tmp/rpm-tmp.5n57PX
+ umask 022
+ cd /builddir/build/BUILD
+ cd netlink-1e2e08e8a2dcdacaae3f14ac44c5cfa31361f270
+ export GOPATH=/builddir/build/BUILDROOT/golang-github-vishvananda-netlink-0-0.8.git1e2e08e.fc25.s390x//usr/share/gocode:/usr/share/gocode
+ GOPATH=/builddir/build/BUILDROOT/golang-github-vishvananda-netlink-0-0.8.git1e2e08e.fc25.s390x//usr/share/gocode:/usr/share/gocode
+ gotest github.com/vishvananda/netlink/nl
+ go test github.com/vishvananda/netlink/nl
# github.com/vishvananda/netlink/nl
../../BUILDROOT/golang-github-vishvananda-netlink-0-0.8.git1e2e08e.fc25.s390x/usr/share/gocode/src/github.com/vishvananda/netlink/nl/nl_linux_test.go:34: msg.X__ifi_pad undefined (type *IfInfomsg has no field or method X__ifi_pad)
FAIL	github.com/vishvananda/netlink/nl [build failed]
error: Bad exit status from /var/tmp/rpm-tmp.5n57PX (%check)
RPM build errors:
    Bad exit status from /var/tmp/rpm-tmp.5n57PX (%check)
Child return code was: 1
EXCEPTION: [Error()]


ppc64:
Executing(%check): /bin/sh -e /var/tmp/rpm-tmp.NZ3Hn3
+ umask 022
+ cd /builddir/build/BUILD
+ cd netlink-1e2e08e8a2dcdacaae3f14ac44c5cfa31361f270
+ export GOPATH=/builddir/build/BUILDROOT/golang-github-vishvananda-netlink-0-0.8.git1e2e08e.fc25.ppc64//usr/share/gocode:/usr/share/gocode
+ GOPATH=/builddir/build/BUILDROOT/golang-github-vishvananda-netlink-0-0.8.git1e2e08e.fc25.ppc64//usr/share/gocode:/usr/share/gocode
+ gotest github.com/vishvananda/netlink/nl
+ go test github.com/vishvananda/netlink/nl
--- FAIL: TestXfrmAlgoDeserializeSerialize (0.00s)
panic: runtime error: slice bounds out of range [recovered]
	panic: runtime error: slice bounds out of range
goroutine 21 [running]:
panic(0x161980, 0xc42000a120)
	/usr/lib/golang/src/runtime/panic.go:500 +0x3a8
testing.tRunner.func1(0xc42008cd80)
	/usr/lib/golang/src/testing/testing.go:579 +0x184
panic(0x161980, 0xc42000a120)
	/usr/lib/golang/src/runtime/panic.go:458 +0x4cc
github.com/vishvananda/netlink/nl.deserializeXfrmAlgoSafe(0xc42001a0e0, 0x64, 0x64, 0x64)
	/builddir/build/BUILDROOT/golang-github-vishvananda-netlink-0-0.8.git1e2e08e.fc25.ppc64/usr/share/gocode/src/github.com/vishvananda/netlink/nl/xfrm_state_linux_test.go:125 +0x35c
github.com/vishvananda/netlink/nl.TestXfrmAlgoDeserializeSerialize(0xc42008cd80)
	/builddir/build/BUILDROOT/golang-github-vishvananda-netlink-0-0.8.git1e2e08e.fc25.ppc64/usr/share/gocode/src/github.com/vishvananda/netlink/nl/xfrm_state_linux_test.go:138 +0x120
testing.tRunner(0xc42008cd80, 0x19ac38)
	/usr/lib/golang/src/testing/testing.go:610 +0xd8
created by testing.(*T).Run
	/usr/lib/golang/src/testing/testing.go:646 +0x370
FAIL	github.com/vishvananda/netlink/nl	0.012s
error: Bad exit status from /var/tmp/rpm-tmp.NZ3Hn3 (%check)
RPM build errors:
    Bad exit status from /var/tmp/rpm-tmp.NZ3Hn3 (%check)
Child return code was: 1
EXCEPTION: [Error()]

Version-Release number of selected component (if applicable):
golang-github-vishvananda-netlink-0-0.8.git1e2e08e.fc25

Comment 2 Jakub Čajka 2016-11-25 11:04:04 UTC
PPC fails seems to me as possible assumed endianity in tests(or elsewhere in code), but I just took really quick glanced on the code.

Comment 3 Fedora Update System 2016-12-14 10:14:35 UTC
golang-github-vishvananda-netlink-0-0.10.gite73bad4.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-1091577904

Comment 4 Fedora Update System 2016-12-14 10:14:55 UTC
golang-github-vishvananda-netlink-0-0.10.gite73bad4.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-7721b4bc95

Comment 5 Dan Horák 2016-12-14 10:32:40 UTC
Thanks for the update, unfortunately the s390x issue is still present in the latest package. Can't be a dependency lacking s390 support?

Comment 6 Dan Horák 2016-12-14 11:04:46 UTC
Executing(%check): /bin/sh -e /var/tmp/rpm-tmp.ukwE3x
+ umask 022
+ cd /home/sharkcz/golang-github-vishvananda-netlink
+ cd netlink-e73bad418fd727ed3a02830b1af1ad0283a1de6c
+ export GOPATH=/home/sharkcz/rpmbuild/BUILDROOT/golang-github-vishvananda-netlink-0-0.10.gite73bad4.fc26.s390x//usr/share/gocode:/usr/share/gocode
+ GOPATH=/home/sharkcz/rpmbuild/BUILDROOT/golang-github-vishvananda-netlink-0-0.10.gite73bad4.fc26.s390x//usr/share/gocode:/usr/share/gocode
+ gotest github.com/vishvananda/netlink/nl
+ go test github.com/vishvananda/netlink/nl
# github.com/vishvananda/netlink/nl
../../rpmbuild/BUILDROOT/golang-github-vishvananda-netlink-0-0.10.gite73bad4.fc26.s390x/usr/share/gocode/src/github.com/vishvananda/netlink/nl/nl_linux_test.go:34: msg.X__ifi_pad undefined (type *IfInfomsg has no field or method X__ifi_pad)
FAIL	github.com/vishvananda/netlink/nl [build failed]
error: Bad exit status from /var/tmp/rpm-tmp.ukwE3x (%check)


RPM build errors:
    Bad exit status from /var/tmp/rpm-tmp.ukwE3x (%check)
Could not execute local: Non zero exit

Comment 7 Dan Horák 2016-12-14 11:23:12 UTC
Looks as a bug in https://golang.org/src/syscall/ztypes_linux_s390x.go

	type IfInfomsg struct {
		Family uint8
		_      uint8
		Type   uint16
		Index  int32
		Flags  uint32
		Change uint32
	}

while https://golang.org/src/syscall/ztypes_linux_ppc64.go contains

type IfInfomsg struct {
		Family     uint8
		X__ifi_pad uint8
		Type       uint16
		Index      int32
		Flags      uint32
		Change     uint32
	}

Comment 8 Dan Horák 2016-12-14 12:09:21 UTC
The corresponding kernel structure is defined in include/uapi/linux/rtnetlink.h as 

struct ifinfomsg {
        unsigned char   ifi_family;
        unsigned char   __ifi_pad;
        unsigned short  ifi_type;               /* ARPHRD_* */
        int             ifi_index;              /* Link index   */
        unsigned        ifi_flags;              /* IFF_* flags  */
        unsigned        ifi_change;             /* IFF_* change mask */
};

Comment 9 Fedora Update System 2016-12-14 15:24:58 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-fb0d06d7e7

Comment 10 Fedora Update System 2016-12-14 15:25:17 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-a3d662dafd

Comment 11 Fedora Update System 2016-12-14 15:25:29 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-ec8568474f

Comment 12 Fedora Update System 2016-12-14 15:25:47 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-22579f80fd

Comment 13 Fedora Update System 2016-12-15 02:49:18 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-fb0d06d7e7

Comment 14 Fedora Update System 2016-12-15 02:50:09 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-ec8568474f

Comment 15 Fedora Update System 2016-12-15 05:04:38 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-22579f80fd

Comment 16 Fedora Update System 2016-12-15 05:08:16 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-a3d662dafd

Comment 17 Dan Horák 2017-02-20 16:58:18 UTC
https://github.com/vishvananda/netlink/commit/a1d6c19f199e20aba37d4322b5d7bf85dc14fae3 fixes the root cause of the s390x issue and will allow to drop the workaround from golang (or sys)

Comment 18 Fedora Update System 2017-03-08 13:22:07 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2017-03-08 13:51:39 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 20 Fedora Update System 2017-03-08 15:48:23 UTC
golang-github-vishvananda-netlink-0-0.11.gite73bad4.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2017-08-24 11:06:11 UTC
golang-github-vishvananda-netlink-0-0.15.gitf5a6f69.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-2a5235eb65

Comment 22 Fedora Update System 2017-08-24 11:06:18 UTC
golang-github-vishvananda-netlink-0-0.15.gitf5a6f69.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-22cc794662

Comment 23 Fedora Update System 2017-08-24 11:06:26 UTC
golang-github-vishvananda-netlink-0-0.15.gitf5a6f69.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-a6febde27f

Comment 24 Fedora Update System 2017-08-24 16:49:08 UTC
golang-github-vishvananda-netlink-0-0.15.gitf5a6f69.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-22cc794662

Comment 25 Fedora Update System 2017-08-24 16:51:56 UTC
golang-github-vishvananda-netlink-0-0.15.gitf5a6f69.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-a6febde27f

Comment 26 Fedora Update System 2017-08-24 23:46:34 UTC
golang-github-vishvananda-netlink-0-0.15.gitf5a6f69.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-2a5235eb65

Comment 27 Fedora End Of Life 2017-11-16 18:41:52 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 28 Fedora End Of Life 2017-12-12 10:19:05 UTC
Fedora 25 changed to end-of-life (EOL) status on 2017-12-12. Fedora 25 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.